7f5dd91a577bfa10fff65e4ab073c72859db9359
[xfstests-dev.git] / 075
1 #! /bin/sh
2 # FS QA Test No. 075
3 #
4 # fsx (non-AIO variant)
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
8 #-----------------------------------------------------------------------
9 #
10 # creator
11 owner=nathans@sgi.com
12
13 seq=`basename $0`
14 echo "QA output created by $seq"
15
16 here=`pwd`
17 tmp=/tmp/$$
18 status=0        # success is the default!
19 trap "_cleanup; exit \$status" 0 1 2 3 15
20
21 _cleanup()
22 {
23     cd /
24     rm -rf $testdir/fsx.* $tmp.*
25     _cleanup_testdir
26 }
27
28 # get standard environment, filters and checks
29 . ./common.rc
30 . ./common.filter
31
32 _do_test()
33 {
34     _n="$1"
35     _param="$2"
36
37     out=$testdir/fsx
38     rm -rf $out
39     if ! mkdir $out
40     then
41         echo "    failed to mkdir $out"
42         status=1
43         exit
44     fi
45
46     _filter_param=`echo "$_param" | sed\
47         -e 's/-N [0-9][0-9]*/-N numops/' \
48         -e 's/-l [0-9][0-9]*/-l filelen/'`
49
50     echo ""
51     echo "-----------------------------------------------"
52     echo "fsx.$_n : $_filter_param"
53     echo "-----------------------------------------------"
54
55     if [ "$FSTYP" = "nfs" ]
56     then
57         if [ "$_n" = "1" -o "$_n" = "3" ]
58         then
59             # HACK: nfs don't handle preallocation (-x) so just skip this test
60             return
61         fi
62     fi
63
64     # This cd and use of -P gets full debug on $here (not TEST_DEV)
65     cd $out
66     if ! $here/ltp/fsx $_param -P $here $seq.$_n >/dev/null
67     then
68         echo "    fsx ($_param) failed, $? - compare $seq.$_n.{good,bad,fsxlog}"
69         mv $out/$seq.$_n $here/$seq.$_n.full
70         od -xAx $here/$seq.$_n.full > $here/$seq.$_n.bad
71         od -xAx $here/$seq.$_n.fsxgood > $here/$seq.$_n.good
72         status=1
73         exit
74     fi
75
76     cd $here
77     _check_test_fs
78 }
79
80 _usage()
81 {
82     echo "$0: [-l filelen] [-n numops1] [-N numops2]"
83 }
84
85 _process_args()
86 {
87     while getopts "l:n:N:?" c $@
88     do
89         case $c
90         in
91             l)
92                 filelen=$OPTARG
93                 param_type="$param_type, overidde -l"
94                 ;;
95             N)
96                 numops2=$OPTARG
97                 param_type="$param_type, overidde -N"
98                 ;;
99             n)
100                 numops1=$OPTARG
101                 param_type="$param_type, overidde -n"
102                 ;;
103             ?)
104                 _usage
105                 exit    
106                 ;;
107         esac
108     done
109 }
110
111
112 # real QA test starts here
113 _supported_fs xfs udf nfs
114 _supported_os IRIX Linux
115
116 size10=`expr 10 \* 1024 \* 1024`        # 10 megabytes
117 filelen=$size10
118 numops1=1000
119 numops2=10000
120
121 # can override the params here
122 _process_args "$@"
123
124 echo "Params are for $param_type" >>$seq.full
125 echo "Params: n = $numops1 N = $numops2 l = $filelen" >>$seq.full
126
127 _setup_testdir
128
129 rm -f $here/$seq.full
130 echo "brevity is wit..."
131
132 _check_test_fs
133
134 # Options:
135 # -d: debug output for all operations
136 # -l flen: the upper bound on file size (default 262144)
137 # -o oplen: the upper bound on operation size
138 # -N numops: total # operations to do (default infinity)
139 # -P: save .fsxlog and .fsxgood files in dirpath (default ./)
140 # -S seed: for random # generator (default 1) 0 gets timestamp
141 # -x: pre-allocate file space, exercising unwritten extents
142
143 _do_test 0 "-d -N $numops1 -S 0"
144 _do_test 1 "-d -N $numops1 -S 0 -x"
145 _do_test 2 "-d -N $numops2 -l $filelen -S 0"
146 _do_test 3 "-d -N $numops2 -l $filelen -S 0 -x"
147
148 rm -f $seq.*.fsx{good,log}
149 exit 0